# 5种物联网正在改变医疗保健的方式

原文链接：[5 Ways the Internet of Things Is Revolutionizing Healthcare](https://www.makeuseof.com/tag/internet-things-revolutionizing-healthcare/)

当大部分人熟悉健身追踪器和一些其他的公共智能设备，互联网真的改变了医疗保健(普通消费者大多没有注意到)。

医疗保健从可穿戴设备和智能设备行业中获益匪浅 - 反过来，可能是医疗行业确保这些设备的成功。从支持蓝牙助听器到机器人称为看护人员，我们将十年前的科幻小说如今用物联网医疗创新实现了。

但技术发展的比你想象得更为先进，就像Freescale Semiconductor在白皮书上指出得：

> “长期预测得医疗保健物联网革命已在进行中...物联网应用在医疗保险应用上扮演了重要得角色，包括从控制一端得慢性病到另一端得疾病预防.”

## 1. 精确的患者情况跟踪

智能穿戴设备对病人和医生都有好处，医生正在使用各种医疗应用程序来跟踪患者的持续健康问题。同时，随着治疗计划的进展，患者能够获得建议和新建议。

 这种跟踪可以在医院进行也可以在家中进行，在某些情况下，该技术有时候会是救星，早在2009年就有一些案例表明，由于他们的Wi-Fi启动心脏起搏器，患者得以挽救，正如[article in the journal *Eurospace*](https://www.ncbi.nlm.nih.gov/pmc/articles/PMC2686319/)所述：

“一个 Medtronic Concerto CRT-D的66岁患者因猝死进行一级预防而打电话给诊所抱怨疲劳两天，没有全身无力感或者ICD电击。远程查询设备.....显示缓慢不规则VT（室性心动过速）。“



医生立刻告诉病人去诊所，就在到达后15分钟，病人就因心脏病发作昏倒，幸运的是，医生已经准备好并能够提供帮助。其他心脏病患者继续受益于该技术，该技术每天都在变得更先进。



<iframe src="https://www.youtube.com/embed/8NUnzz0onrY?feature=oembed" frameborder="0" allowfullscreen="" name="fitvid0" style="user-select: text !important; position: absolute; top: 0px; left: 0px; width: 670px; height: 376.538px;"></iframe>



## 2. 智能健康援助

不是所有的智能设备都是用来拯救生命，一些是给患有慢性病或者残疾患者在平时生活中使用的，使生活更为容易。

关于糖尿病，激发了许多智能设备的发展，这些连接设备不仅可以帮助患者检测他们的状况，还可以帮他们预防疾病。



[iHealth Smart,](https://ihealthlabs.com/glucometer/wireless-smart-gluco-monitoring-system/) 比如，蓝牙设备可以帮助使用者追踪他们的葡萄糖水平，它配有一个配对的应用程序，以帮助他们理解和跟踪数据。

![ihealth-smart](https://static.makeuseof.com/wp-content/uploads/2017/09/ihealth-smart-670x445.png)

连接版的日常用品也起到了作用，比如 [Siren Smart Socks](https://siren.care/)使用温度监控来帮助使用者预防足部溃疡——这是血多糖尿病患者面临的并发症。袜子将这些数据发送匹配的app，这个应用程序会通知使用者检查足部检查，换一双鞋子，减少活动或者去看医生。

一些连接设备则是为患者的生活添加了便利，这是 [Widex COM-DEX](https://global.widex.com/en/hearing-aids/hearing-aid-accessories/dex-hearing-aid-remote-controls/com-dex)所实现的，支持蓝牙的 [助听器](https://www.makeuseof.com/tag/how-hearing-aids-work/) ，用户可以使用app进行调整和自定义。

[一个简单的概述关于助听器如何工作？](https://www.makeuseof.com/tag/how-hearing-aids-work/) [How Do Hearing Aids Work? A Simple Overview](https://www.makeuseof.com/tag/how-hearing-aids-work/)如果你认为助听器和音频放大器差不多，那你会很惊讶的发现你错了，以下使这项神奇的技术实际工作方式！



这个连接了用户的手机也会带来些其他的便利，比如可以直接通过助听器来打电话或者听音乐。



<iframe src="https://www.youtube.com/embed/s7-xRcsMtDY?feature=oembed" frameborder="0" allowfullscreen="" name="fitvid1" style="user-select: text !important; position: absolute; top: 0px; left: 0px; width: 670px; height: 376.538px;"></iframe>



“我选择智能助听器主要是因为它的大小和风格。我还喜欢这样一个事实，即我可以通过COM-DEX从我的手机控制它，“该设备的用户Amy Bell告诉MakeUseOf。

由于潜水事故损害了她的耳蜗毛细胞，Bell的一只耳朵需要助听器。她对高音调敏感，所以她无法正常的听到低音或重低音。



“随着COM-DEX连接到我的助听器和手机，我能够通过助听器听到电话以及播放音乐。更大或更老的型号没有这个功能，“她说。

## 3. 智能手术

[Google Glass](https://www.makeuseof.com/tag/google-glass-make-job-easier/)在商业上可能比较失败，但是通过为工厂的工作人员提供增强现实(AR)眼镜，找到了自己的市场。

[Google Glass Is Back to Make Your Job Easier](https://www.makeuseof.com/tag/google-glass-make-job-easier/) 

但工厂不是唯一使用这种技术的地方。事实上，AR辅助手术已经成为现实。

其他公司也正在为手术创建增强现实工具，例如Augmedics。该公司正在开发一款名为 [The Vizor](https://www.augmedics.com/technology)的AR头戴设备，它将允许医生在手术过程中查看患者的CT扫描。



<iframe src="https://www.youtube.com/embed/KHCL_Rd5kjo?feature=oembed" frameborder="0" allowfullscreen="" name="fitvid2" style="user-select: text !important; position: absolute; top: 0px; left: 0px; width: 670px; height: 376.538px;"></iframe>



Augmedics相信使用AR头戴设备可以进行微创脊柱手术，因为该技术减少了对大切口的需求。

与此同时，另一家名为**Scopis**的公司将微软HoloLens与他们的手术导航技术相结合。通过这样做，他们创建了一个系统，为外科医生提供许多程序的AR指导。

![scopis-mixed-reality](https://static.makeuseof.com/wp-content/uploads/2017/09/scopis-670x378.png)

> “Scopis’全息导航平台是一种通用解决方案，可为脊柱外科手术提供特定的优势，也可应用于最高精度和速度至关重要的许多其他领域。 。 。例如，在神经外科手术中，脑肿瘤的定位速度更快，准确度更高。” — Brian Kosmecki, Scopis CEO

## 4. 预防性医疗保健和早期检测

通过连接设备提供大量的数据，使研究人员可以分析患者的趋势和风险。虽然它目前还不是是一门精确的学科，但更多的公司正在研究有助于预防性医疗保险数据的解决方案。

Pwc推出了一款名为 **Bodylogical** 的预测引擎用来处理患者数据，以帮助提供未来潜在的健康趋势和问题有关的健康见解。消费者设备可以使用引擎为用户提供他们的决定对他们的健康的可能影响。



<iframe src="https://www.youtube.com/embed/VsqKxpFLiUo?feature=oembed" frameborder="0" allowfullscreen="" name="fitvid3" style="user-select: text !important; position: absolute; top: 0px; left: 0px; width: 670px; height: 376.538px;"></iframe>



“[通过来自可穿戴设备，连接设备，或者其他消费者数据源的数据],Bodylogical可以想象人们目前的选择-无论是积极的还是消极的-将会如何影响他们。它可以向人们展示如何以最少的努力，得到最好的结果，或者可以帮助一个人的注意力集中在一个或者两个特定的事物上，可以获得很大的提高。” — PwC

这包括在智能手机上向用户发送通知，来提醒他们。

同时，连接设备也是早期发现疾病和健康问题的有力工具，例如，Cyrcadia Health有一种名为iTBra的设备，可以帮助早期发现乳腺癌。



![itbra smart](https://static.makeuseof.com/wp-content/uploads/2017/09/itbra-534x500.jpg)Image Credit: Cyrcadia Health



智能乳房贴片使用预测分析软件和算法来识别乳房组织中的潜在异常。该数据被发送到Cyrcadia Health进行分析，结果会发送给用户和医生。

## 5. 机器人医疗保健助理

还记得我们提到的那些科幻场景么？这个新技术无疑是你可能在科幻小说中所期待的。如今，机器人医疗保险助理已经实现了。

众所周知，智能传感器是老年人在家中保持独立的一种方式，但IBM和莱斯大学正在进一步推动**Multi-Purpose Eldercare Robot Assistant** (IBM MERA)。该技术仍处于早期阶段，但原型已于2016年底投入使用。



![healthcare-robot](https://static.makeuseof.com/wp-content/uploads/2017/09/health-robot-670x446.jpg)Image Credit: Jack Plunkett/IBM



> “IBM MERA将用于帮助研究测量个体生命体征的创新方法，例如心率，心率变异性和呼吸频率;回答与健康有关的基本问题;并通过读取加速度计的结果来确定个人是否已经跌倒。” — IBM

PwC Global研究指出 [AI and robots](https://www.makeuseof.com/tag/home-robots-need-see-believe/) 在医疗行业发挥着越来越重要的作用。更令人惊讶的是，该公司发现公众已经准备好接收这些进步。他们的调查显示，世界各地的消费者已经准备好采用旨在实现健康和保健的新技术。

[10个你可以信赖的家庭机器人](https://www.makeuseof.com/tag/home-robots-need-see-believe/) [10 Home Robots You Need to See to Believe](https://www.makeuseof.com/tag/home-robots-need-see-believe/)可能需要很多年才能从“The Jetsons”购买具有Rosie智能和功能的机器人。尽管如此，今天的机器人正在向这个方向发展。[READ MORE](https://www.makeuseof.com/tag/home-robots-need-see-believe/)

> “信息非常明确：公众已经准备和愿意 [人工智能和机器人代替人类](https://www.makeuseof.com/tag/will-android-apps-replace-doctor/).”
>
> [未来这些安卓APP会代替医生么?](https://www.makeuseof.com/tag/will-android-apps-replace-doctor/) [Will These Android Apps Replace Your Doctor?](https://www.makeuseof.com/tag/will-android-apps-replace-doctor/)这些医疗app非常有用，即便如此，它们也不会取代你的医生。.[READ MORE](https://www.makeuseof.com/tag/will-android-apps-replace-doctor/)

另一个名为 [Giraff](http://www.giraff.org/?lang=en)的机器人解决方案可以帮助那些患有慢性疾病的人，机器人便于那些被限制在家中或床上的人通过视频的喂食和机器人的运动来进行虚拟访问。



![giraff-robot](https://static.makeuseof.com/wp-content/uploads/2017/09/giraff-670x487.jpg)Image Credit: Giraff



同时，机器人在患者的日常生活中也很有帮助，可以监控他们的健康并于医疗保健的专业人士进行咨询。患者亦可以通过远程护理机器人与亲人进行互动。

## 双向性

连接设备在医疗护理上并不是片面的，实质上，医疗保健行业是智能设备行业创新和生产的主要驱动力之一，当涉及到可穿戴设备时，这尤其普遍。

[全球行业分析公司](http://www.strategyr.com/pressMCP-7956.asp) 预测到2020年可穿戴设备医疗市场价值将打到45亿美金，该公司表示，这是由于“对慢性病有效管理的需求日益增长”。

公司的一份报告表明：“从患者使用这些设备使得全球可穿戴设厂获得了持续的动力” 。

它还指出，人们对医疗保健的负担能力的逐渐担忧，使人们对使用连接设备来管理慢性病感兴趣

Statista的数据显示，2015年至2016年间，医疗保健可穿戴设备的销售收入增长了两倍。到2017年底，他们预计收入将比2016年增加2.5倍。

所以，这样看来物联网使得医疗保健有了巨大的改善，但是互联设备行业也在医疗保健中收获了巨大的市场。

## 缺点?

在物联网和医疗保健方面，有个大问题：数据隐私。. [智能设备存在安全和隐私问题](https://www.makeuseof.com/tag/5-new-gadgets-present-new-security-privacy-issues/). 如今，黑客不断寻找利用这项技术 [收集用户信息](https://www.makeuseof.com/tag/your-information-exploited/).

[5个对安全和隐私问题构成威胁的新技术](https://www.makeuseof.com/tag/5-new-gadgets-present-new-security-privacy-issues/) [5 New Gadgets That Present New Security & Privacy Issues](https://www.makeuseof.com/tag/5-new-gadgets-present-new-security-privacy-issues/)为什么我们的安全和隐私随着新的技术设备或工具的发布会变得更糟糕，下面使目前对您的安全和隐私构成威胁的五项新技术[READ MORE](https://www.makeuseof.com/tag/5-new-gadgets-present-new-security-privacy-issues/)

对于医疗保健中的物联网而言，这并没有什么不同。特别是，起搏器一直是发现安全方面主要漏洞的头条新闻。

IBM的米兰帕特尔在该公司的安全情报网站上指出，这些设备存在安全风险，其中许多消费者并未意识到这一点。

![privacy security](https://static.makeuseof.com/wp-content/uploads/2017/09/privacy-security-670x425.jpg)

“在健康和健身设备中增长的[网络安全漏洞](https://www.makeuseof.com/tag/smart-home-internet-things-vulnerabilities/) 列表给那些隐私或健康管理取决于这些工具正常运行的患者带来了挑战。“Patel在 [他的帖子](https://securityintelligence.com/the-security-and-privacy-of-wearable-health-and-fitness-devices/)说到。

[您的智能家居是否会受到物联网漏洞的威胁？](https://www.makeuseof.com/tag/smart-home-internet-things-vulnerabilities/) [I您的智能家居是否会受到物联网漏洞的威胁？](https://www.makeuseof.com/tag/smart-home-internet-things-vulnerabilities/)物联网安全么？可能你希望使这样的，但是最近一项研究强调，几年前提出的安全问题尚未解决，你的智能家居可能会有风险。[READ MORE](https://www.makeuseof.com/tag/smart-home-internet-things-vulnerabilities/)

“解决使用这些设备带来的相关安全和隐私问题的关键使数据的释放对于社会没有利益。”

## 我们未来可以期待什么？

凭借医疗保健在物联网行业发展中发挥的关键作用，以及公众不断寻求保护自身健康的方法，智能医疗设备的革命没有放缓的迹象。

我们许多最疯狂的梦想都会成真，你可以期待医疗机器人和人工智能等创新变得更为先进和可靠。

智能救护车正在多个地区开发，紧急救护车将在急救中心和求助人之间传递实时信息，这将加快提供救治的速度。

同事，各种公司开发智能药丸作为可植入传感器，来追踪药物与患者的相互作用，甚至还有智能隐形眼镜的消息。

**哪种健康设备是你期待的？你现在在用么？请在下面的评论中告诉我们！**