# 管理人脸识别AI的时间还很长

原文链接：[High Time to Regulate Face Recognition A.I.](https://medium.com/intuitionmachine/high-time-to-begin-regulation-of-face-recognition-a-i-f4a92ee40165?from=hackcv&hmsr=hackcv.com)

我们已经到了一个转折点，现在正是我们开始调整人脸识别人工智能（AI）的对话的时候了。

在上一篇[文章中](https://medium.com/intuitionmachine/how-to-regulate-artificial-intelligence-10725701043b)，我探讨了一些关于如何规范人工智能的想法。我查看了其他领域的几个法规，并探讨了如何申请AI。反对人工智能监管最引人注目的论点是，对于许多人来说，确切地说需要监管的内容并不清楚。然而，最近几天，我注意到一种特定的AI算法需要认真考虑规则。

[斯坦福大学的研究人员](https://osf.io/zn79k/)已经培训了一种深度学习系统来识别一个人的性取向。我不怀疑他们建立的系统的有效性。然而，许多人质疑研究人员的解释。但是，我非常关注滥用这种技术的可能性。



![img](https://cdn-images-1.medium.com/max/800/1*5VhzZSfzf-ETGjy7fx-abQ.jpeg)

来源: [Deep neural networks are more accurate than humans at detecting sexual orientation from facial images.](https://osf.io/zn79k/)

今年5月，中国研究人员开发了一种更加值得怀疑的面部分类系统，确定某人是否可能成为犯罪分子。

![img](https://cdn-images-1.medium.com/max/800/1*EEhfnjTH_nNHDwiXwwby8g.jpeg)

论文: [Automated Inference on Criminality using Face Images](https://arxiv.org/pdf/1611.04135.pdf)

我们现在迫切需要分析面部识别的好处大于风险。我将对此进行一次尝试，并最终提出风险大于收益的论点。

以下是面部识别的一些好处：

**安全性**  - 面部识别现已内置于iPhone X中（请参阅：[面部识别码](https://www.wired.com/story/iphone-x-faceid-security/)），并用作解锁手机的身份验证机制。以前，iPhone（其他智能手机）使用一个指纹来解锁设备。面部识别还可用于监控访问家庭或办公室的人。

**社交参与**  - Facebook可以自动标记照片中的面孔。此功能的价值在于增加被标记的人以及跟随其他人的人的参与度。Facebook增加了额外的安全功能，允许用户选择退出自动面部标记功能。

**安全性** - 在车身监控设备中可以确定驾驶员是否暂时分心。该申请可用于任何需要受雇工人集中注意力的工作相关活动。

**医疗保健**  - 为生病或残疾人士提供的监控设备可能有助于为他们的需求提供更具响应性的医疗服务。

**娱乐**  - 虚拟现实或增强现实游戏可能会对参与者的情绪做出反应。

**生产力**  - Google相册使用面部识别功能自动整理和搜索自己的个人照片。

**执法**  - 面部识别可用于识别刑事调查中的嫌疑人。这也可用于跟踪和查找失踪人员。

以下是潜在风险：

**法治国家**  - 面部识别允许各州追踪其公民的行动和行为。这允许各州强制遵守其议程。

**生物识别**  - 面部识别可以识别一个人的性取向。在许多国家，一个人的性取向可以作为犯罪行为受到惩罚。这样的系统可以变得多么准确，这可能是有争议的。但是，如果政府对其准确性感到满意，那么人们就会因为他们是谁而不是他们所做的而受到惩罚。识别到一个人的传承或种族是另一个可能被滥用的领域。

**行为操纵**  - 这涉及在不同背景下识别人的面部反应。识别厌恶或敬畏之类的反应可能向观察者表明一个人的内在个人观点。利用这些信息允许其他方（即营销，销售，政府，雇主等）执行可能与个人福祉相冲突的行为操纵技术。我们已经在社交网络中见证了这些行为技巧，以影响一个人的行为。

**行为执法**  - 可以对工人进行监控，以评估他们对手头任务的持续关注。不认真工作将受到扣发工资的惩罚。

关于风险，我现在就在这里停下来。有很多风险在这里我故意没有提到。人们甚至可以进行推断在未来的情况，很容易想象出一种我们会后悔让机器识别我们的情景。

然而，为什么面部识别是一个如此危险的想法，这里的一般总体原则是什么？第一个问题是因为它是通过自动化执行的，所以它可以大规模地完成并且毫无感情地完成。这导致了我们与大型互联网公司相同的隐私问题。第二个问题也是隐私问题，即我们内心的想法和偏好应该保密。第三个问题是机器进行简易判断的可能性。对于人类来说，懒惰地依赖算法来执行判断而不是自己这样做是非常容易的。此外，有一个算法做出判断，在许多方面清洗一个人来清除任何后果的责任。当判断标准基于你的外表时，这种判断会更加糟糕。

照片复印机受到管制，无法复制和打印合法纸币。任何打印机中的软件都是硬连线的，用于检测货币中的特定签名，从而防止传真复制。类似地，可能需要要求任何新的深度学习芯片（具有足够的性能）使任何面部识别任务无效。或者，在没有必要的“安全芯片”的情况下，将深度学习设备与图像捕获系统连接起来应该是非法的。

较轻的监管形式应允许任何人选择退出面部识别。它可以通过使用一种用户佩戴的标记或代码（可能是额头上的条形码？）来实现。这类似于美国发现的自我识别种族形式。根据法律，任何人都应该被允许选择退出面部识别软件。替代方案将是一种新的时尚：

![img](https://cdn-images-1.medium.com/max/800/1*r1N9X-eFEUDm2FSibwdJ3g.jpeg)

来源: <https://cvdazzle.com/#style-tips>

我绝对肯定许多人工智能研究人员会对这项监管提案表示支持。但是，您需要能够证明面部识别功能的好处绝对大于风险。风险是非常真实的，现在是我们开始认真讨论的时候了。

**进一步阅读**

[**面部识别软件尚未准备好供执法部门使用**](https://techcrunch.com/2018/06/25/facial-recognition-software-is-not-ready-for-use-by-law-enforcement/)



![img](https://cdn-images-1.medium.com/max/800/1*j9kar_3vwdJK8twhtmXC0g.png)

更多报道：<https://gumroad.com/products/WRbUs>