# 8 Essential Tips for People starting a Career in Data Science

原文链接：[8 Essential Tips for People starting a Career in Data Science](https://www.analyticsvidhya.com/blog/2017/10/tips-people-starting-career-data-science/?from=hackcv&hmsr=hackcv.com&utm_medium=hackcv.com&utm_source=hackcv.com)

## Introduction

Learning data science can be intimidating. Specially so, when you are just starting your journey. Which tool to learn – R or Python? What techniques to focus on? How much statistics to learn? Do I need to learn coding? These are some of the many questions you need to answer as part of your journey.

That is why I thought that I would create this guide, which could help people starting in Analytics or Data Science. The idea was to create a simple, not very long guide which can set your path to learn data science. This guide would set a framework which can help you learn data science through this difficult and intimidating period.

 

Just follow through these tips and you will get a good head start in your career.

So let’s get started!

 

### 1. Choose the right role

There are a lot of varied roles in data science industry. A data visualization expert, a machine learning expert, a data scientist, data engineer etc are a few of the many roles that you could go into. Depending on your background and your work experience, getting into one role would be easier than another role. For example, if you a software developer, it would not be difficult for you to shift into data engineering. So, until and unless you are clear about what you want to become, you will stay confused about the path to take and skills to hone.

What to do, if you are not clear about the differences or you are not sure what should you become? I few things which I would suggest are:

- Talk to people in industry to figure out what each of the roles entail
- Take mentorship from people – request them for a small amount of time and ask relevant questions. I’m sure no one would refuse to help a person in need!
- Figure out what you want and what you are good at and choose the role that suits your field of study.

Here is a descriptive comparison done by Analytics Vidhya a few months back on what is it like being a [Data Scientist vs Data Engineer vs Statistician](https://www.analyticsvidhya.com/blog/2015/10/job-comparison-data-scientist-data-engineer-statistician/). I’m sure it will help you reach your decision.

A point to keep in mind when choosing a role: don’t just hastily jump on to a role. You should first understand clearly what the field requires and prepare for it.

 

### 2. Take up a Course and Complete it

Now that you have decided on a role, the next logical thing for you is to put in dedicated effort to understand the role. This means not just going through the requirements of the role. The demand for data scientists is big so thousands of courses and studies are out there to hold your hand, you can learn whatever you want to. Finding material to learn from isn’t a hard call but learning it may become if you don’t put efforts.

What you can do is take up a MOOC which is freely available, or join an accreditation program which should take you through all the twists and turns the role entails. The choice of free vs paid is not the issue, the main objective should be whether the course clears your basics and brings you to a suitable level, from which you can push on further.

When you take up a course, go through it actively. Follow the coursework, assignments and all the discussions happening around the course. For example, if you want to be a machine learning engineer, you can take up Machine learning by Andrew Ng. Now you have to diligently follow all the course material provided in the course. This also means the assignments in the course, which are as important as going through the videos. Only doing a course end to end will give you a clearer picture of the field.

Some good MOOCs to look for include:

1. Analytics Edge on edX
2. Machine Learning from Andrew Ng

 

### 3. Choose a Tool / Language and stick to it

As I mentioned before, it is important for you to get an end-to-end experience of whichever topic you pursue. A difficult question which one faces in getting hands-on is which language/tool should you choose?

This would probably be the most asked question by beginners. The most straight-forward answer would be to choose any of the mainstream tool/languages there is and start your data science journey. After all, tools are just means for implementation; but understanding the concept is more important.

Still the question remains, which would be a better option to start with? There are [various guides](https://www.analyticsvidhya.com/blog/2017/09/sas-vs-vs-python-tool-learn/) / discussions on the internet which address this particular query. The gist is that start with the simplest of language or the one with which you are most familiar with. if you are not as well versed with coding, you should prefer GUI based tools for now. Then as you get a grasp on the concepts, you can get your hands on with the coding part.

 

### 4. Join a peer group

Now that you know that which role you want to opt for and are getting prepared for it, the next important thing for you to do would be to join a peer group. Why is this important? This is because a peer group keeps you motivated. Taking up a new field may seem a bit daunting when you do it alone, but when you have friends who are alongside you, the task seems a bit easier.

The most preferable way to be in a peer group is to have a group of people you can physically interact with.  Otherwise you can either have a bunch of people over the internet who share similar goals, such as joining a Massive online course and interacting with the batch mates.

Even if you don’t have this kind of peer group, you can still have a meaningful technical discussion over the internet. There are online forums which give you this kind of environment. I will list a few of them

1. [Analytics Vidhya](https://discuss.analyticsvidhya.com/)
2. [StackExchange](https://stackexchange.com/)
3. [Reddit](https://www.reddit.com/)

 

### 5. Focus on practical applications and not just theory

While undergoing courses and training, you should focus on the practical applications of things you are learning. This would help you not only understand the concept but also give you a deeper sense on how it would be applied in reality.

A few tips you should do when following a course:

- Make sure you do all the exercises and assignments to understand the applications.
- Work on a few open data sets and apply your learning. Even if you don’t understand the math behind a technique initially, understand the assumptions, what it does and how to interpret the results. You can always develop a deeper understanding at a later stage.
- Take a look at the solutions by people who have worked in the field. They would be able to pinpoint you with the right approach faster.

 

### 6. Follow the right resources

To never stop learning, you have to engulf each and every source of knowledge you can find. The most useful source of this information is blogs run by most influential Data Scientists. These Data Scientists are really active and update the followers on their findings and frequently post about the recent advancement in this field.

Read about data science every day and make it a habit to be updated with the recent happenings. But there may be many resources, influential data scientists to follow, and you have to be sure that you don’t follow the incorrect practices. So it is very important to follow the right resources.

Here is a [list of Data Scientists](https://www.analyticsvidhya.com/blog/2015/09/ultimate-data-scientists-world-today/) that you can follow. These are few newsletters to keep you on the go.

1. [WildML](http://www.wildml.com/)
2. [NYU](https://cds.nyu.edu/newsletter/)
3. [KDnuggets News](http://www.kdnuggets.com/)

 

### 7. Work on your Communication skills

People don’t usually associate communication skills with rejection in data science roles. They expect that if they are technically profound, they will ace the interview. This is actually a myth. Ever been rejected within an interview, where the interviewer said thank you after listening to your introduction?

Try this activity once; make your friend with good communication skills hear your intro and ask for honest feedback. He will definitely show you the mirror!

Communication skills are even more important when you are working in the field. To share your ideas to a colleague or to prove your point in a meeting, you should know how to communicate efficiently.

 

### 8. Network, but don’t waste too much time on it!

Initially, your entire focus should be on learning. Doing too many things at initial stage will eventually bring you up to a point where you’ll give up.

Gradually, once you have got a hang of the field, you can go on to attend industry events and conferences, popular meetups in your area, participate in hackathons in your area – even if you know only a little. You never know who, when and where will help you out!

Actually, a meetup is very advantageous when it comes down to making your mark in the data science community. You get to meet people in your area who work actively in the field, which provides you networking opportunities along with establishing a relationship with them will in turn help you advance your career heavily. A networking contact might:

- Give you inside information of what’s happening in your field of interest
- help you to have mentorship support
- Help you search for a Job, this would either be tips on job hunting through leads or possible employment opportunities directly.

 

## End Notes

The demand of data science is huge and employers are investing significant time and money in Data Scientists. So taking the right steps will lead to an exponential growth. This guide provides tips that can get you started and help you to avoid some costly mistakes.

If you went through a similar experience in the past and want to share this with the community, do comments below!

### [Learn](https://www.analyticsvidhya.com/blog), [engage,](https://discuss.analyticsvidhya.com/) [compete,](https://datahack.analyticsvidhya.com/) and [get hired](https://www.analyticsvidhya.com/jobs/#/user/)!

You can also read this article on Analytics Vidhya's Android APP

 

![Get it on Google Play](https://play.google.com/intl/en_us/badges/images/generic/en_badge_web_generic.png)



TAGS : [BECOME A DATA SCIENTIST](https://www.analyticsvidhya.com/blog/tag/become-a-data-scientist/), [DATA SCIENCE](https://www.analyticsvidhya.com/blog/tag/data-science/), [DATA SCIENCE CAREER](https://www.analyticsvidhya.com/blog/tag/data-science-career/), [TIPS FOR GETTING INTO DATA SCIENCE](https://www.analyticsvidhya.com/blog/tag/tips-for-getting-into-data-science/)