# Learning Maths for Machine Learning and Deep Learning

原文链接：[Learning Maths for Machine Learning and Deep Learning](https://medium.com/towards-data-science/learning-maths-for-machine-learning-and-deep-learning-5509c097ee83?from=hackcv&hmsr=hackcv.com&utm_medium=hackcv.com&utm_source=hackcv.com)

While I did learn a lot of maths while doing my engineering degree, I forgot most of it by the time I wanted to get into Machine Learning. After I graduated I never really had a need for any of the maths. I did a lot of web programming which relied on logic and I can honestly say that with each system with the word ‘Management’ in the title I lost a third of my math knowledge! I’ve programmed extensions for Learning Management Systems, Content Management Systems and Customer Relationship Management Systems — I’ll leave you to figure out how much math apptitude I had after working with these systems. At the moment I’ve got good data science skills and can use a variety of ML and DL algorithms. I’ve successfully completed a number of MOOCs (e.g., Deep Learning Foundations from Udacity and Andrew Ng’s new Coursera courses). I can use Scikit Learn, TensorFlow and Kera’s. …. but I have rough ideas for creating new variants of algorithms. At the moment I really want to create a new kind of interactive topic modeling algorithm. I’ve felt stuck due to my lack of maths knowledge. In my travels trying to re-learn some basic maths, I’ve come across a couple of books that have been written by people with the art of explanation. These books have made a tremendous difference as they are able to convey complex concepts in a very simple manner. I am writing this blog post to share these great resources especially for programmers. The books cover Calculus and Linear Algebra. I’ve not found an equivalent Probability and Statistics book yet — If you know of one please leave a comment or tweet [Aneesha Bakharia](https://medium.com/@aneesha).

### Calculus Made Easy by S. Thompson

Learn calculus from a book written in 1914! The [pdf for the book](http://djm.cc/library/Calculus_Made_Easy_Thompson.pdf) is freely available. This book is simply amazing. The English is a bit old style but the explanations are timeless. Thompson makes calculus super easy. Optimization of a cost function is core to ML and DL and this book will help you understand the basics of minimization. Those update rules in gradients decent won’t seem like magic anymore. Just read the prologue — its set the tone for the rest of the book…



![img](https://cdn-images-1.medium.com/max/1000/1*idSk5MAMQC7eNzg29PqOIQ.png)

The Prologue from Calculus Made Easy by S. Thompson

### Coding the Matrix by P. N. Klein

Most Linear Algebra books start easy but then concepts like image, basis, dimension, orthogonalization, eigenvectors are introduced in a completely abstract way. Most Linear Algebra books fail to even introduce real world applications and its hard to see where or why you would use the math. Matrix multiplication is a good example of something I learnt but never truely understood (i.e., why is was not performed element by element). [Coding the Matrix](http://codingthematrix.com/) is different! You actually get to build your own linear algebra library while improving your Python programming skills! The book is full of practical computer science applications (e.g. fix the perspective of a whiteboard photograph).



![img](https://cdn-images-1.medium.com/max/1000/1*RshBwDdVw5oGoFVRgh-y-w.png)

Coding the Matrix — the best Linear Algebra book ever!